#ifndef __HASHTAB_H__
#define __HASHTAB_H__

/*
 * Copyright  2014 The MorphOS Development Team
 *
 * $Id: hashtab.h,v 1.1 2014/02/15 19:46:06 itix Exp $
 */

#include <sys/types.h>

#include <exec/types.h>

typedef struct
{
	CONST_APTR value;
	size_t     key;
} Bucket;

typedef struct
{
	size_t   allocsize;

	size_t   hash_offset;
	size_t   hash_size;

	size_t  *chaining;

	Bucket   buckets[0];
} hashtable;

#define HASH_INDEX(__hash, __id) ((size_t)(__id + __hash->hash_offset) % __hash->hash_size)

CONST_APTR hashtab_get(const hashtable *h, CONST_APTR val, size_t stringNum);

#endif /* __HASHTAB_H__ */
